//+------------------------------------------------------------------+
//|                                                     SA_Price.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
//#property indicator_minimum -1.5
//#property indicator_maximum 1.5
#property indicator_buffers 3
#property indicator_color1 LawnGreen
#property indicator_color2 Gold
#property indicator_color3 FireBrick

extern int Range=8;
extern int Shift=3;
extern int OfPoint=0;
extern int Counter=300;


double OpenBuf[];
double CloseBuf[];
double PercentBuf[];
double PriceOpen;
double PriceClose;
double PriceMax;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,OpenBuf);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(1,CloseBuf);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(2,PercentBuf);
   IndicatorShortName("SA_Price("+Range+","+Shift+")");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double UpValue=0;
   double UpPrev[5]={0,0,0,0,0};
   double DnValue=0;
   double DnPrev[5]={0,0,0,0,0};
   
   int Rx;
   if (Shift<=0) Shift=1;
   PriceMax=0;
   int    counted_bars=IndicatorCounted();
   if (Counter==0) Counter=Bars;
   
   for (int Ix=Counter-Range;Ix>=0;Ix--)
   {
      PriceOpen=0;
      PriceClose=0;
      for (Rx=Ix;Rx<=Ix+Range;Rx++)
      {
      PriceOpen=PriceOpen+(iOpen(NULL,0,Ix)-iClose(NULL,0,Rx+Shift))/iClose(NULL,0,Rx+Shift)*100;
      PriceClose=PriceClose+(iClose(NULL,0,Ix)-iOpen(NULL,0,Rx+Shift))/iOpen(NULL,0,Rx+Shift)*100;
      }
      OpenBuf[Ix]=PriceOpen;
      CloseBuf[Ix]=PriceClose;
//        if (PriceOpen!=0)  PercentBuf[Ix]=(PriceOpen/Range)/(PriceMax/Range); else PercentBuf[Ix]=0;
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+